Index: trunk/modules/vci_mem_cache_v4/caba/source/include/vci_mem_cache_v4.h
===================================================================
--- trunk/modules/vci_mem_cache_v4/caba/source/include/vci_mem_cache_v4.h	(revision 253)
+++ trunk/modules/vci_mem_cache_v4/caba/source/include/vci_mem_cache_v4.h	(revision 273)
@@ -587,54 +595,54 @@
       ///////////////////////////////////////////////////////
 
-      sc_signal<int>       r_sc_fsm;                        // FSM state
-      sc_signal<data_t>	   r_sc_wdata;	                    // write data word
-      sc_signal<data_t>	   *r_sc_rdata;	                    // read data word
-      sc_signal<uint32_t>  r_sc_lfsr;                       // lfsr for random introducing
-      sc_signal<size_t>    r_sc_cpt;  	                    // size of command
-      sc_signal<copy_t>    r_sc_copy; 	                    // Srcid of the first copy
-      sc_signal<copy_t>    r_sc_copy_cache;                 // Srcid of the first copy
-      sc_signal<bool>      r_sc_copy_inst;	                // Type of the first copy
-      sc_signal<size_t>    r_sc_count;	                    // number of copies
-      sc_signal<size_t>    r_sc_ptr;  	                    // pointer to the heap
-      sc_signal<size_t>    r_sc_next_ptr;  	                // next pointer to the heap
-      sc_signal<bool>      r_sc_is_cnt;	                    // is_cnt bit (in directory)
-      sc_signal<bool>      r_sc_dirty;	                    // dirty bit (in directory)
-      sc_signal<size_t>    r_sc_way;		                // way in directory
-      sc_signal<size_t>    r_sc_set;		                // set in directory
-      sc_signal<data_t>    r_sc_tag;		                // cache line tag (in directory)
-      sc_signal<size_t>    r_sc_trt_index;                  // Transaction Table index
-      sc_signal<size_t>    r_sc_upt_index;                  // Update Table index
-
-      // Buffer between SC fsm and INIT_CMD fsm (XRAM read)	
-      sc_signal<bool>	   r_sc_to_ixr_cmd_req;             // valid request
-      sc_signal<addr_t>	   r_sc_to_ixr_cmd_nline;           // cache line index
-      sc_signal<size_t>	   r_sc_to_ixr_cmd_trdid;           // index in Transaction Table
-      sc_signal<bool>	   r_sc_to_ixr_cmd_write;           // write request
-      sc_signal<data_t>	  *r_sc_to_ixr_cmd_data;            // cache line data
+      sc_signal<int>      r_sc_fsm;        // FSM state
+      sc_signal<data_t>   r_sc_wdata;      // write data word
+      sc_signal<data_t> * r_sc_rdata;      // read data word
+      sc_signal<uint32_t> r_sc_lfsr;       // lfsr for random introducing
+      sc_signal<size_t>   r_sc_cpt;        // size of command
+      sc_signal<copy_t>   r_sc_copy;       // Srcid of the first copy
+      sc_signal<copy_t>   r_sc_copy_cache; // Srcid of the first copy
+      sc_signal<bool>     r_sc_copy_inst;  // Type of the first copy
+      sc_signal<size_t>   r_sc_count;      // number of copies
+      sc_signal<size_t>   r_sc_ptr;        // pointer to the heap
+      sc_signal<size_t>   r_sc_next_ptr;   // next pointer to the heap
+      sc_signal<bool>     r_sc_is_cnt;     // is_cnt bit (in directory)
+      sc_signal<bool>     r_sc_dirty;      // dirty bit (in directory)
+      sc_signal<size_t>   r_sc_way;        // way in directory
+      sc_signal<size_t>   r_sc_set;        // set in directory
+      sc_signal<data_t>   r_sc_tag;        // cache line tag (in directory)
+      sc_signal<size_t>   r_sc_trt_index;  // Transaction Table index
+      sc_signal<size_t>   r_sc_upt_index;  // Update Table index
+
+      // Buffer between SC fsm and INIT_CMD fsm (XRAM read)
+      sc_signal<bool>     r_sc_to_ixr_cmd_req;   // valid request
+      sc_signal<addr_t>   r_sc_to_ixr_cmd_nline; // cache line index
+      sc_signal<size_t>   r_sc_to_ixr_cmd_trdid; // index in Transaction Table
+      sc_signal<bool>     r_sc_to_ixr_cmd_write; // write request
+      sc_signal<data_t> * r_sc_to_ixr_cmd_data;  // cache line data
 
 
       // Buffer between SC fsm and TGT_RSP fsm
-      sc_signal<bool>	   r_sc_to_tgt_rsp_req;             // valid request
-      sc_signal<data_t>    r_sc_to_tgt_rsp_data;            // read data word
-      sc_signal<size_t>	   r_sc_to_tgt_rsp_srcid;           // Transaction srcid
-      sc_signal<size_t>	   r_sc_to_tgt_rsp_trdid;           // Transaction trdid
-      sc_signal<size_t>	   r_sc_to_tgt_rsp_pktid;           // Transaction pktid
+      sc_signal<bool>     r_sc_to_tgt_rsp_req;   // valid request
+      sc_signal<data_t>   r_sc_to_tgt_rsp_data;  // read data word
+      sc_signal<size_t>   r_sc_to_tgt_rsp_srcid; // Transaction srcid
+      sc_signal<size_t>   r_sc_to_tgt_rsp_trdid; // Transaction trdid
+      sc_signal<size_t>   r_sc_to_tgt_rsp_pktid; // Transaction pktid
 
       // Buffer between SC fsm and INIT_CMD fsm (Update/Invalidate L1 caches)
-      sc_signal<bool>	   r_sc_to_init_cmd_multi_req;      // valid request
-      sc_signal<bool>	   r_sc_to_init_cmd_brdcast_req;    // brdcast request
-      sc_signal<addr_t>	   r_sc_to_init_cmd_nline;	        // cache line index
-      sc_signal<size_t>	   r_sc_to_init_cmd_trdid;	        // index in Update Table
-      sc_signal<data_t>    r_sc_to_init_cmd_wdata;          // data (one word)
-      sc_signal<bool>      r_sc_to_init_cmd_is_long;        // it is a 64 bits SC
-      sc_signal<data_t>    r_sc_to_init_cmd_wdata_high;     // data high (one word)
-      sc_signal<size_t>	   r_sc_to_init_cmd_index;	        // index of the word in line
-      GenericFifo<bool>    m_sc_to_init_cmd_inst_fifo;      // fifo for the L1 type
-      GenericFifo<size_t>  m_sc_to_init_cmd_srcid_fifo;     // fifo for srcids
-      GenericFifo<size_t>  m_sc_to_init_cmd_cache_id_fifo;  // fifo for srcids
+      sc_signal<bool>     r_sc_to_init_cmd_multi_req;     // valid request
+      sc_signal<bool>     r_sc_to_init_cmd_brdcast_req;   // brdcast request
+      sc_signal<addr_t>   r_sc_to_init_cmd_nline;         // cache line index
+      sc_signal<size_t>   r_sc_to_init_cmd_trdid;         // index in Update Table
+      sc_signal<data_t>   r_sc_to_init_cmd_wdata;         // data (one word)
+      sc_signal<bool>     r_sc_to_init_cmd_is_long;       // it is a 64 bits SC
+      sc_signal<data_t>   r_sc_to_init_cmd_wdata_high;    // data high (one word)
+      sc_signal<size_t>   r_sc_to_init_cmd_index;         // index of the word in line
+      GenericFifo<bool>   m_sc_to_init_cmd_inst_fifo;     // fifo for the L1 type
+      GenericFifo<size_t> m_sc_to_init_cmd_srcid_fifo;    // fifo for srcids
+      GenericFifo<size_t> m_sc_to_init_cmd_cache_id_fifo; // fifo for srcids
 
       // Buffer between SC fsm and INIT_RSP fsm (Decrement UPT entry)
-      sc_signal<bool>      r_sc_to_init_rsp_req;            // valid request
-      sc_signal<size_t>    r_sc_to_init_rsp_upt_index;      // index in update table
+      sc_signal<bool>     r_sc_to_init_rsp_req;       // valid request
+      sc_signal<size_t>   r_sc_to_init_rsp_upt_index; // index in update table
 
       ////////////////////////////////////////////////////
@@ -642,10 +650,10 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 	   r_ixr_rsp_fsm;       // FSM state
-      sc_signal<size_t>	   r_ixr_rsp_trt_index;	// TRT entry index
-      sc_signal<size_t>    r_ixr_rsp_cpt;	    // word counter
+      sc_signal<int>      r_ixr_rsp_fsm;       // FSM state
+      sc_signal<size_t>   r_ixr_rsp_trt_index; // TRT entry index
+      sc_signal<size_t>   r_ixr_rsp_cpt;       // word counter
 
       // Buffer between IXR_RSP fsm and XRAM_RSP fsm  (response from the XRAM)
-      sc_signal<bool>	  *r_ixr_rsp_to_xram_rsp_rok;	// A xram response is ready
+      sc_signal<bool>   * r_ixr_rsp_to_xram_rsp_rok; // A xram response is ready
 
       ////////////////////////////////////////////////////
@@ -653,46 +661,46 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 	   r_xram_rsp_fsm;		        // FSM state
-      sc_signal<size_t>	   r_xram_rsp_trt_index;	    // TRT entry index
-      TransactionTabEntry  r_xram_rsp_trt_buf;		    // TRT entry local buffer
-      sc_signal<bool>	   r_xram_rsp_victim_inval;	    // victim line invalidate 
-      sc_signal<bool>	   r_xram_rsp_victim_is_cnt;    // victim line inst bit
-      sc_signal<bool>	   r_xram_rsp_victim_dirty;	    // victim line dirty bit
-      sc_signal<size_t>    r_xram_rsp_victim_way;	    // victim line way
-      sc_signal<size_t>    r_xram_rsp_victim_set;	    // victim line set
-      sc_signal<addr_t>    r_xram_rsp_victim_nline;     // victim line index
-      sc_signal<copy_t>    r_xram_rsp_victim_copy;  	// victim line first copy
-      sc_signal<copy_t>    r_xram_rsp_victim_copy_cache;// victim line first copy
-      sc_signal<bool>      r_xram_rsp_victim_copy_inst;	// victim line type of first copy
-      sc_signal<size_t>    r_xram_rsp_victim_count;	    // victim line number of copies
-      sc_signal<size_t>    r_xram_rsp_victim_ptr;       // victim line pointer to the heap
-      sc_signal<data_t>	  *r_xram_rsp_victim_data;	    // victim line data
-      sc_signal<size_t>	   r_xram_rsp_upt_index;	    // UPT entry index
-      sc_signal<size_t>    r_xram_rsp_next_ptr;         // Next pointer to the heap
+      sc_signal<int>      r_xram_rsp_fsm;               // FSM state
+      sc_signal<size_t>   r_xram_rsp_trt_index;         // TRT entry index
+      TransactionTabEntry r_xram_rsp_trt_buf;           // TRT entry local buffer
+      sc_signal<bool>     r_xram_rsp_victim_inval;      // victim line invalidate
+      sc_signal<bool>     r_xram_rsp_victim_is_cnt;     // victim line inst bit
+      sc_signal<bool>     r_xram_rsp_victim_dirty;      // victim line dirty bit
+      sc_signal<size_t>   r_xram_rsp_victim_way;        // victim line way
+      sc_signal<size_t>   r_xram_rsp_victim_set;        // victim line set
+      sc_signal<addr_t>   r_xram_rsp_victim_nline;      // victim line index
+      sc_signal<copy_t>   r_xram_rsp_victim_copy;       // victim line first copy
+      sc_signal<copy_t>   r_xram_rsp_victim_copy_cache; // victim line first copy
+      sc_signal<bool>     r_xram_rsp_victim_copy_inst;  // victim line type of first copy
+      sc_signal<size_t>   r_xram_rsp_victim_count;      // victim line number of copies
+      sc_signal<size_t>   r_xram_rsp_victim_ptr;        // victim line pointer to the heap
+      sc_signal<data_t> * r_xram_rsp_victim_data;       // victim line data
+      sc_signal<size_t>   r_xram_rsp_upt_index;         // UPT entry index
+      sc_signal<size_t>   r_xram_rsp_next_ptr;          // Next pointer to the heap
 
       // Buffer between XRAM_RSP fsm and TGT_RSP fsm  (response to L1 cache)
-      sc_signal<bool>	   r_xram_rsp_to_tgt_rsp_req;	// Valid request
-      sc_signal<size_t>    r_xram_rsp_to_tgt_rsp_srcid;	// Transaction srcid
-      sc_signal<size_t>    r_xram_rsp_to_tgt_rsp_trdid;	// Transaction trdid
-      sc_signal<size_t>    r_xram_rsp_to_tgt_rsp_pktid;	// Transaction pktid
-      sc_signal<data_t>   *r_xram_rsp_to_tgt_rsp_data;	// data (one cache line)
-      sc_signal<size_t>    r_xram_rsp_to_tgt_rsp_word;  // first word index
-      sc_signal<size_t>    r_xram_rsp_to_tgt_rsp_length;// length of the response
-      sc_signal<bool>      r_xram_rsp_to_tgt_rsp_rerror;// send error to requester
-
-      // Buffer between XRAM_RSP fsm and INIT_CMD fsm (Inval L1 Caches) 
-      sc_signal<bool>	    r_xram_rsp_to_init_cmd_multi_req;       // Valid request
-      sc_signal<bool>       r_xram_rsp_to_init_cmd_brdcast_req;     // Broadcast request
-      sc_signal<addr_t>     r_xram_rsp_to_init_cmd_nline;           // cache line index;
-      sc_signal<size_t>	    r_xram_rsp_to_init_cmd_trdid;           // index of UPT entry
-      GenericFifo<bool>     m_xram_rsp_to_init_cmd_inst_fifo;       // fifo for the L1 type
-      GenericFifo<size_t>   m_xram_rsp_to_init_cmd_srcid_fifo;      // fifo for srcids
-      GenericFifo<size_t>   m_xram_rsp_to_init_cmd_cache_id_fifo;      // fifo for srcids
+      sc_signal<bool>     r_xram_rsp_to_tgt_rsp_req;    // Valid request
+      sc_signal<size_t>   r_xram_rsp_to_tgt_rsp_srcid;  // Transaction srcid
+      sc_signal<size_t>   r_xram_rsp_to_tgt_rsp_trdid;  // Transaction trdid
+      sc_signal<size_t>   r_xram_rsp_to_tgt_rsp_pktid;  // Transaction pktid
+      sc_signal<data_t> * r_xram_rsp_to_tgt_rsp_data;   // data (one cache line)
+      sc_signal<size_t>   r_xram_rsp_to_tgt_rsp_word;   // first word index
+      sc_signal<size_t>   r_xram_rsp_to_tgt_rsp_length; // length of the response
+      sc_signal<bool>     r_xram_rsp_to_tgt_rsp_rerror; // send error to requester
+
+      // Buffer between XRAM_RSP fsm and INIT_CMD fsm (Inval L1 Caches)
+      sc_signal<bool>     r_xram_rsp_to_init_cmd_multi_req;     // Valid request
+      sc_signal<bool>     r_xram_rsp_to_init_cmd_brdcast_req;   // Broadcast request
+      sc_signal<addr_t>   r_xram_rsp_to_init_cmd_nline;         // cache line index;
+      sc_signal<size_t>   r_xram_rsp_to_init_cmd_trdid;         // index of UPT entry
+      GenericFifo<bool>   m_xram_rsp_to_init_cmd_inst_fifo;     // fifo for the L1 type
+      GenericFifo<size_t> m_xram_rsp_to_init_cmd_srcid_fifo;    // fifo for srcids
+      GenericFifo<size_t> m_xram_rsp_to_init_cmd_cache_id_fifo; // fifo for srcids
 
       // Buffer between XRAM_RSP fsm and IXR_CMD fsm (XRAM write)
-      sc_signal<bool>	   r_xram_rsp_to_ixr_cmd_req;	// Valid request
-      sc_signal<addr_t>	   r_xram_rsp_to_ixr_cmd_nline;	// cache line index
-      sc_signal<data_t>	  *r_xram_rsp_to_ixr_cmd_data;	// cache line data
-      sc_signal<size_t>	   r_xram_rsp_to_ixr_cmd_trdid;	// index in transaction table
+      sc_signal<bool>     r_xram_rsp_to_ixr_cmd_req;   // Valid request
+      sc_signal<addr_t>   r_xram_rsp_to_ixr_cmd_nline; // cache line index
+      sc_signal<data_t> * r_xram_rsp_to_ixr_cmd_data;  // cache line data
+      sc_signal<size_t>   r_xram_rsp_to_ixr_cmd_trdid; // index in transaction table
 
       ////////////////////////////////////////////////////
@@ -700,6 +708,6 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 	   r_ixr_cmd_fsm;
-      sc_signal<size_t>	   r_ixr_cmd_cpt;
+      sc_signal<int>      r_ixr_cmd_fsm;
+      sc_signal<size_t>   r_ixr_cmd_cpt;
 
       ////////////////////////////////////////////////////
@@ -707,6 +715,6 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 	   r_tgt_rsp_fsm;
-      sc_signal<size_t>    r_tgt_rsp_cpt;
+      sc_signal<int>      r_tgt_rsp_fsm;
+      sc_signal<size_t>   r_tgt_rsp_cpt;
 
       ////////////////////////////////////////////////////
@@ -714,5 +722,5 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 	  r_init_cmd_fsm;
+      sc_signal<int>      r_init_cmd_fsm;
       sc_signal<size_t>   r_init_cmd_cpt;
       sc_signal<bool>     r_init_cmd_inst;
@@ -722,5 +730,6 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 		r_alloc_dir_fsm;
+      sc_signal<int>      r_alloc_dir_fsm;
+      sc_signal<unsigned> r_alloc_dir_reset_cpt;
 
       ////////////////////////////////////////////////////
@@ -728,5 +737,5 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 		r_alloc_trt_fsm;
+      sc_signal<int>      r_alloc_trt_fsm;
 
       ////////////////////////////////////////////////////
@@ -734,5 +743,5 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 		r_alloc_upt_fsm;
+      sc_signal<int>      r_alloc_upt_fsm;
 
       ////////////////////////////////////////////////////
@@ -740,6 +749,6 @@
       ////////////////////////////////////////////////////
 
-      sc_signal<int> 		r_alloc_heap_fsm;
-
+      sc_signal<int>      r_alloc_heap_fsm;
+      sc_signal<unsigned> r_alloc_heap_reset_cpt;
     }; // end class VciMemCacheV4
 
@@ -755,4 +764,4 @@
 // End:
 
-// vim: filetype=cpp:expandtab:shiftwidth=4:tabstop=4:softtabstop=4
-
+// vim: filetype=cpp:expandtab:shiftwidth=2:tabstop=2:softtabstop=2
+
